REM https://github.com/uclouvain/openjpeg/archive/v2.3.0.tar.gz

set ARCH=%1

if "%ARCH%"=="x86" (
	set OSGEO4W_ROOT=C:\OSGeo4W
	set VCARCH=x86
	set CMAKEGEN=Visual Studio 14 2015
	set ZLIB=zlib.lib
) else (
	set OSGEO4W_ROOT=C:\OSGeo4W64
	set VCARCH=x64
	set CMAKEGEN=Visual Studio 14 2015 Win64
	set ZLIB=zdll.lib
)

set P=openjpeg
set V=2.3.0
set B=1

set R=..\..\..\%ARCH%\release\%P%
if not exist %R% mkdir %R%

set pf=%ProgramFiles(x86)%
if "%pf%"=="" set pf=%ProgramFiles%
call "%pf%\Microsoft Visual Studio 14.0\VC\vcvarsall.bat" %VCARCH%
echo on
path C:\Program Files\CMake\bin;%pf%\Microsoft Visual Studio 14.0\Common7\IDE;c:\cygwin\bin;%PATH%

mkdir build-%ARCH%
cd build-%ARCH%

cmake -G "%CMAKEGEN%" ^
	-D CMAKE_INSTALL_PREFIX=../install-%ARCH% ^
	-D PNG_PNG_INCLUDE_DIR=%OSGEO4W_ROOT%/libs/vc14/include ^
	-D PNG_LIBRARY=%OSGEO4W_ROOT%/libs/vc14/lib/libpng16.lib ^
	-D ZLIB_INCLUDE_DIR=%OSGEO4W_ROOT%/include ^
	-D ZLIB_LIBRARY=%OSGEO4W_ROOT%/lib/%ZLIB% ^
	-D TIFF_INCLUDE_DIR=%OSGEO4W_ROOT%/include ^
	-D TIFF_LIBRARY=%OSGEO4W_ROOT%/lib/libtiff_i.lib ^
	../..
if errorlevel 1 (echo cmake error & goto error)

devenv OPENJPEG.sln /Project ALL_BUILD /Clean Release
if errorlevel 1 (echo build error & goto error)

devenv OPENJPEG.sln /Project ALL_BUILD /Build Release
if errorlevel 1 (echo build error & goto error)

devenv OPENJPEG.sln /Project INSTALL /Build Release
if errorlevel 1 (echo install error & goto error)

cd ..

copy setup.hint %R%\setup.hint
copy ..\LICENSE %R%\%P%-%V%-%B%.txt

tar -C install-%ARCH% -cjf %R%\%P%-%V%-%B%.tar.bz2 ^
	--exclude bin/msvcp140.dll ^
	--exclude bin/vcruntime140.dll ^
	--exclude bin/concrt140.dll ^
	bin/openjp2.dll include lib
if errorlevel 1 (echo tar pkg error & goto error)

tar -C .. -cjf %R%\%P%-%V%-%B%-src.tar.bz2 osgeo4w/package.cmd osgeo4w/setup.hint
if errorlevel 1 (echo tar src error & goto error)

exit

:error
